#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#if HAVE_UNISTD_H
#include <unistd.h>
#endif
#if STDC_HEADERS
# include <string.h>
#else
# ifndef HAVE_STRCHR
#  define strchr index
# endif
char *strchr();
#endif

char *crypt(const char *plaintext, const char *salt);

extern char *getpass();

int main(int argc, char *argv[])
{
  static char saltChars[] = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789./";
  char salt[3];
  char * plaintext;

  if (argc <= 2) {
    srandom(time(0));		/* may not be the BEST salt, but its close */
    salt[0] = saltChars[random() % 64];
    salt[1] = saltChars[random() % 64];
    salt[2] = 0;
  }
  else {
    salt[0] = argv[1][0];
    salt[1] = argv[1][1];
    salt[2] = '\0';
    if ((strchr(saltChars, salt[0]) == NULL) || (strchr(saltChars, salt[1]) == NULL))
      fprintf(stderr, "illegal salt %s\n", salt), exit(1);
  }

  if (argc == 1) 
  {
     plaintext = getpass("plaintext: ");
     printf("%s\n", crypt(plaintext, salt));
     return 0;
  }
  else if(argc == 2)
  {
     printf("%s\n", crypt(argv[1], salt));
     return 0;
  }
  else
  {
     printf("%s\n", crypt(argv[2], salt));
     return 0;
  }
}
