/* CS6 - Channel Services src/bancmp.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include<bot.h>

int bancmp(const char *mask, const char *name)
{
   const char *m = mask;
   const char *n = name;
   const char *ma = mask;
   const char *na = name;
   int wild = 0;
   int q = 0;

   while (1)
   {
      if (*m == '*')
      {
	 while (*m == '*')
	    m++;
	 wild = 1;
	 ma = m;
	 na = n;
      }

      if (!*m)
      {
	 if (!*n)
	    return 0;
	 for (m--; (m > mask) && (*m == '?'); m--)
	    ;
	 if ((*m == '*') && (m > mask) &&
	    (m[-1] != '\\'))
	    return 0;
	 if (!wild)
	    return 1;
	 m = ma;
	 n = ++na;
      }
      else if (!*n)
      {
	 while (*m == '*')
	    m++;
	 return (*m != 0);
      }
      if ((*m == '\\') && ((m[1] == '*') || (m[1] == '?')))
      {
	 m++;
	 q = 1;
      }
      else
	 q = 0;

      if ((tolower(*m) != tolower(*n)) && ((*m != '?') || q))
      {
	 if (!wild)
	    return 1;
	 m = ma;
	 n = ++na;
      }
      else
      {
	 if (*m)
	    m++;
	 if (*n)
	    n++;
      }
   }
}

/*
int bancmp(const char *mask, const char *name)
{
  const char *m = mask;
  const char *n = name;
  const char *ma = mask;
  const char *na = name;
  int wild = 0;
  int q = 0;

  while (1)
  {
    if (*m == '*')
    {
      while (*m == '*')
	m++;
      wild = 1;
      ma = m;
      na = n;
    }

    if (!*m)
    {
      if (!*n)
        return 0;
      for (m--; (m > mask) && (*m == '?'); m--)
	;
      if ((*m == '*') && (m > mask) &&
	  (m[-1] != '\\'))
        return 0;
      if (!wild)
	return 1;
      m = ma;
      n = ++ na;
    }
    else if (!*n)
    {
      while (*m == '*')
	m++;
      return (*m != 0);
    }
    if ((*m == '\\') && ((m[1] == '*') || (m[1] == '?')))
    {
      m++;
      q = 1;
    }
    else
      q = 0;

    if ((tolower(*m) != tolower(*n)) && ((*m != '?') || q))
    {
      if (!wild)
	return 1;
      m = ma;
      n = ++na;
    }
    else
    {
      if (*m)
	m++;
      if (*n)
	n++;
    }
  }
}
*/

char *collapse(char *pattern)
{
   Reg1 char *s = pattern, *s1, *t;

   if (BadPtr(pattern))
      return pattern;
   for (; *s; s++)
      if (*s == '\\')
	 if (!*(s + 1))
	    break;
	 else
	    s++;
      else if (*s == '*')
      {
	 if (*(t = s1 = s + 1) == '*')
	    while (*t == '*')
	       t++;
	 else if (*t == '?')
	    for (t++, s1++; *t == '*' || *t == '?'; t++)
	       if (*t == '?')
		  *s1++ = *t;
	 while ((*s1++ = *t++));
      }
   return pattern;
}

int wwcmp(char *wld1, char *str1)
{
   char st[100], sub[100], *wld, *str, *ptr, *wptr, *sptr;
   int i, j, in = 0;
   wptr = (char *) calloc(1, (char *) strlen(wld1) + 5);
   sptr = (char *) calloc(1, (char *) strlen(str1) + 5);
   wld = wptr;
   str = sptr;
   strcpy(wld, wld1);
   strcpy(str, str1);
   if(!(*wld) || !(*str)) 
   {
      free(sptr);
      free(wptr);
      return 1;
   }
   if(*wld == '*')
      if(!*++wld)
      {
         free(sptr);
         free(wptr);
         return 0;
      }
      else wld--;
   if(*str == '*')
      if(!*++str)
      {
         free(sptr);
         free(wptr);
         return 0;
      }
      else str--;
   if(*wld=='*'&&*(wld+1)=='@'&&*(wld+2)=='*'||
      *str=='*'&&*(str+1)=='@'&&*(str+2)=='*')
      {
         free(sptr);
         free(wptr);
         return 0;
      }
   if(*wld == '*' && *(str+strlen(str)-1)=='*') 
   {
      wld++;
      *(str+strlen(str)-1) = '\0';
   }
   if(*str == '*' && *(wld+strlen(wld)-1)=='*') 
   {
      str++;
      *(wld+strlen(wld)-1) = '\0';
   }
   if(*wld == '?' && *(str+strlen(str)-1)=='?') 
   {
      wld++;
      *(str+strlen(str)-1) = '\0';
   }
   if(*str == '?' && *(wld+strlen(wld)-1)=='?') 
   {
      str++;
      *(wld+strlen(wld)-1) = '\0';
   }
   while(*wld || *str) 
   {
      if(tolower(*wld) == tolower(*str) && *wld != '*' && *str != '*'
         && *wld != '?' && *str != '?') 
      {
         wld++;
         str++;
      }
      else if((*str != '*' && *wld == '?') ||
         (*str == '?' && *wld != '*')) 
         {
            wld++;
            str++;
         }
      else if((tolower(*wld) != tolower(*str) && *wld == '*') ||
         (*wld == '*' && *str == '*') &&
            *str != '?' && *wld != '?') 
         {
            i = 0;
            while(*wld == '*' && *wld) 
            {
               wld++;
               if(!*wld)
               {
                  free(sptr);
                  free(wptr);
                  return 0;
               }
            }
            while(wld[i] && wld[i] != '*' && wld[i] != '?') 
            {
               st[i] = wld[i];
               i++;
            }
            st[i] = '\0';
            ptr = str;
            while(*str && (j=comp(st, str, strlen(st)))) 
            {
               if(*str == '*') 
               {
                  in = 1;
               }
               str++;
            }
            if(in && j) 
            {
               str = ptr;
               while(*str && (j=comp(st, str, strlen(st)))) 
               {
                  if(*str == '*') 
                  {
                     break;
                  }
                  str++;
               }
            }
            in = 0;
         }
      else if((tolower(*wld) != tolower(*str) && *str == '*') ||
         (*wld == '*' && *str == '*') &&
            *str != '?' && *wld != '?') 
         {
            i = 0;
            while(*str == '*' && *str) 
            {
               str++;
               if(!*str)
               {
                  free(sptr);
                  free(wptr);
                  return 0;
               }
            }
            while(str[i] && str[i] != '*' && str[i] != '?') 
            {
               st[i] = str[i];
               i++;
            }
            st[i] = '\0';
            strcpy(sub, str);
            ptr = wld;
            while(*wld && (j=comp(st, wld, strlen(st)))) 
            {
               if(*wld == '*') 
               {
                  in = 1;
               }
               wld++;
            }
            if(in && j) 
            {
               wld=ptr;
               while(*wld && (j=comp(st, wld, strlen(st)))) 
               {
                  if(*wld == '*') 
                  {
                     break;
                  }
                  wld++;
               }
            }
            in = 0;
         }
      else if(tolower(*wld) != tolower(*str))
      {
         free(sptr);
         free(wptr);
         return 1;
      }
   }
   free(sptr);
   free(wptr);
   return 0;
}

int comp(char *str1, char *str2, int len)
{
   int i = 0;
   while(*str1 && i < len)
   {
      if(tolower(*str1) == tolower(*str2))
      {
         str1++;
         str2++;
      }
      else if(*str1 == '?' || *str2 == '?' || *str1 == '*' || *str2 == '*')
      {
         str1++;
         str2++;
      }
      else if(*str1 && !*str2) return 1;
      else if(tolower(*str1) != tolower(*str2)) return 1;
      i++;
   }
   return 0;
}

int bancmp1(char *str_1, char *str_2)
{
   char *domain1, *domain2, *str1, *str2, *sstr1, *sstr2;
   sstr1 = (char *) malloc((char *) strlen(str_1) + 1);
   sstr2 = (char *) malloc((char *) strlen(str_2) + 1);
   str1 = sstr1;
   str2 = sstr2;
   strcpy(str1, str_1);
   strcpy(str2, str_2);
   if(domain1 = strchr(str1, '@')) *domain1++ = '\0';
   else 
   {
      free(sstr1);
      free(sstr2);
      return 1;
   }
   if(domain2 = strchr(str2, '@')) *domain2++ = '\0';
   else
   {
      free(sstr1);
      free(sstr2);
      return 1;
   }
   if(!wwcmp(str1, str2))
      if(!wwcmp(domain1, domain2))
      {
         free(sstr1);
         free(sstr2);
         return 0;
      }
   free(sstr1);
   free(sstr2);
   return 1;
}
