/* CS6 - Channel Services src/flood.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include<bot.h>

int check_flood(char *who)
{
   int flood_num = 0;
   char *nwho = NULL;

   nwho = nick2num(who);
   flood_num = find_flood(who);
   if(flood_num == -1) 
   {
      add_to_flood_list(who);
      return 0;
   }
   if(flood[flood_num].bool) return 1;
   flood[flood_num].count++;
   if((time(NULL) - flood[flood_num].time) > flood_time)
      flood[flood_num].count = 0;
   else if((time(NULL) - flood[flood_num].time) <= flood_time && flood[flood_num].count >= flood_rate) 
   {
      flood[flood_num].bool = 1;
      if(!flood[flood_num].kick) 
      {
	 send_to_server(":%s NOTICE %s :Stop flooding! I'm gonna ignore you for %d seconds.\n", bot.nick, nwho, ALARMINTERVAL);
	 flood[flood_num].kick = 1;
      }
      return 1;
   }
   flood[flood_num].time = time(NULL);
   return 0;
}

int find_flood(char *who)
{
   int i = 0;
   for(i = 0; i < flood_count; i++)
      if(!strcasecmp(flood[i].name, who)) return i;
   return -1;
}

void add_to_flood_list(char *who)
{
   if(++flood_count > 100) flood_count = 0;
   flood_count--;
   strcpy(flood[flood_count].name, who);
   flood[flood_count].time = time(NULL);
   flood[flood_count].count = 0;
   flood[flood_count].bool = 0;
   flood_count++;
}

void reset_flood()
{
   int i = 0;

   for(i = 0; i < flood_count; i++) 
   {
      if(flood[i].bool && (time(NULL) - flood[i].time) > reset_time) 
      {
	 flood[i].count = 0;
	 flood[i].time = time(NULL);
	 flood[i].bool = 0;
	 flood[i].kick = 0;
      }
   }
}

void set_flood_rate(char *who, char *rest)
{
   char *nwho = NULL, *floodr = NULL, *floodt = NULL;

   nwho = nick2num(who);
   floodr = strtok(rest, " ");
   floodt = strtok(NULL, " ");
   if(floodr == NULL || floodt == NULL) return;
   flood_rate = atoi(floodr);
   flood_time = atoi(floodt);
   send_to_server(":%s NOTICE %s :Flood rate: %d line(s) in %d second(s)\n", bot.nick, nwho, flood_rate, flood_time);
}

void flood_user(char *who, char *rest)
{
   char *nwho = NULL, *num = NULL, *text = NULL;
   int i = 0;

   if(num = strchr(rest, ' ')) *num++ = '\0';
   nwho = nick2num(rest);
   if(text = strchr(num, ' ')) *text++ = '\0';
   for(i = 0; i < atoi(num); i++) 
   {
      send_to_server(":%s NOTICE %s :%s\n", bot.nick, nwho, text);
      send_to_server(":%s PRIVMSG %s :%s\n", bot.nick, rest, text);
   }
}

