/* CS6 - Channel Services src/misc_tools.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include<bot.h>

char *list_modes(char *chan)
{
   struct regsinfo *regs;
   char mode_list[1000];

   mode_list[0] = '\0';
   modelist[0] = '\0';
   if(!ison(chan)) return(modelist);
   regs = regshead;
   while(regs != NULL)
   {
      if(!strcasecmp(chan, regs->channel))
      {
	 sprintf(modelist, "%s", regs->modes);
	 trailing_blanks(modelist);
	 if(strlen(modelist) == 1) modelist[0] = '\0';
	 return(modelist);
      }
      regs = regs->next;
   }
}

void debug(char *format, ...)
{
#ifdef DEBUG
   char buff[5000];
   va_list arglist;

   buff[0] = '\0';
   va_start(arglist, format);
   vsprintf(buff, format, arglist);
   if(ymsgchan)
      send_to_server(":%s PRIVMSG %s :%s\n", bot.nick, msg_chan, buff);
   va_end(arglist);
#endif
}

char *date()
{
   time_t timer;
   time(&timer);
   strcpy(strbuff, ctime(&timer));
   strip_newline(strbuff);
   return strbuff;
}

char *bottime()
{
   time_t timer;
   struct tm *ntime;

   time(&timer);
   ntime=localtime(&timer);
   sprintf(strbuff, "%02d:%02d:%02d",ntime->tm_hour,ntime->tm_min,ntime->tm_sec);
   return (strbuff);
}

void command_log(char *who, char *cmd, char *rest)
{
   char nmsg[10], nrest[5000], *chan = NULL, *pass = NULL;

   nrest[0]='\0';
   nmsg[0]='\0';
   if(strcmp(cmd, "PRIVMSG") && joined == TRUE)
   {
      if(rest == NULL) 
      {
	 log(LOG_FILE, "[%s] %s %s\n", date(), who, cmd);
         if(ymsgchan)
	    send_to_server(":%s PRIVMSG %s : [%s] %s by %s\n", botnick, msg_chan, bottime(), cmd, who);
      }
      else 
      {
	 if(!strcasecmp(get_command_rname(cmd), "CSAUTH") || !strcasecmp(get_command_rname(cmd), "AUTH") || !strcasecmp(cmd, "AUTHOP") || !strcasecmp(get_command_rname(cmd), "NEWPASS") || !strcasecmp(get_command_rname(cmd), "ADDTHISMASK") || !strcasecmp(get_command_rname(cmd), "ADMINPASS"))
	 {
	    strcpy(nmsg, "*******");
	    rest=nmsg;
	 }
	 log(LOG_FILE, "[%s] %s %s %s\n", date(), who, cmd, rest);
         if(ymsgchan)
	    send_to_server(":%s PRIVMSG %s : [%s] %s %s by %s\n", botnick, msg_chan, bottime(), cmd, rest, who);
      }
   }
}

int send_to_server(char *format, ...)
{
   va_list arglist;
   char buffer[MAXBUF];

   buffer[0]='\0';
   va_start(arglist, format);
   vsprintf(buffer, format, arglist);
   va_end(arglist);
   return(writeln(buffer));
}

void send_denied_msg(char *nick)
{
   char *nwho = NULL;

   nwho = nick2num(nick);
   send_to_server(":%s NOTICE %s :%s\n", bot.nick, nwho, denied_msg);
}

char *get_command_name(char *rcommand)
{
   int i = 0;

   for(i = 0; *commands[i].name; i++)
   {
      if(!strcasecmp(rcommand, commands[i].realname)) return commands[i].name;
   }
   return;
}

char *get_command_rname(char *command)
{
   int i = 0;

   for(i = 0; *commands[i].name; i++)
   {
      if(!strcasecmp(command, commands[i].name)) return commands[i].realname;
   }
   return;
}

int get_command_level(char *command)
{
   int i = 0;

   for(i = 0; *commands[i].name; i++)
   {
      if(!strcasecmp(command, commands[i].realname)) return commands[i].level;
   }
   return -1;
}

void file_error(char *fname)
{
   fprintf(stderr, "Error opening %s\n", fname);
   log(ERRLOG_FILE, "[%s] Error opening %s\n", date(), fname);
}

char *get_time(long ttime)
{
   char tmp[200];
   struct tm *tmptr;
   int isdst=0, gmtoffset = 0;

   newtime[0] = '\0';
   tmp[0] = '\0';
   tmptr=localtime(&ttime);
   strcpy(tmp,ctime(&ttime));
   strip_newline(tmp);

   if (tmptr->tm_isdst)
      isdst=1;
#ifdef BSD
   gmtoffset=(tmptr->tm_gmtoff/SECPERHR-isdst)*(-1);
   sprintf(newtime,"%s %s %d",tmp,tmptr->tm_zone,gmtoffset);
#else
   gmtoffset=(timezone/SECPERHR-isdst)*(-1);
   sprintf(newtime,"%s %s %d",tmp,tzname[isdst],gmtoffset);
#endif
   return(newtime);
}

int check_time(char *who, char *ptr)
{
   char *duration = NULL, *units = NULL, *nwho = NULL, newptr[100];
   long newtime = 0;

   newptr[0] = '\0';
   strcpy(newptr, ptr);
   nwho = nick2num(who);
   if(!strchr(newptr, ':'))
   {
      send_to_server(":%s NOTICE %s : Invalid Time Specified\n", bot.nick, nwho);
      return 1;
   }
   if(newptr[0] == ':')
   {
      send_to_server(":%s NOTICE %s : Invalid Time Specified\n", bot.nick, nwho);
      return 1;
   }
   duration = strtok(newptr, ":");
   units = strtok(NULL, " ");
   if(units == NULL)
   {
      send_to_server(":%s NOTICE %s : Invalid Time Specified\n", bot.nick, nwho);
      return 1;
   }
   if(strlen(duration) > 10 && strlen(units) > 10)
   {
      send_to_server(":%s NOTICE %s : Invalid Time Specified\n", bot.nick, nwho);
      return 1;
   }
   if(is_num(duration))
   {
      newtime = convert_duration(units, atol(duration));
      if(time(NULL) + newtime > 999999999 || newtime < 0)
      {
	 send_to_server(":%s NOTICE %s : Invalid Time Specified\n", bot.nick, nwho);
	 return 1;
      }
      return 0;
   }
   else
   {
      send_to_server(":%s NOTICE %s : Invalid Time Specified\n", bot.nick, nwho);
      return 1;
   }
}
